//
//  NSString+SHA1Addition.m
//
//  Created by Renat Karimov
//

#import "NSString+SHA1Addition.h"
#import <CommonCrypto/CommonDigest.h>

@implementation NSString(Hash)

- (NSString *) sha1Value {
    
    if (self == nil || [self length] == 0) {
        return nil;
    }
    
    const char *value = [self UTF8String];
    
    unsigned char digest[CC_SHA1_DIGEST_LENGTH];
    if (CC_SHA1(value, (CC_LONG)strlen(value), digest)) {
        NSMutableString *resultString = [[NSMutableString alloc] initWithCapacity:CC_SHA1_DIGEST_LENGTH * 2];
        for (NSInteger count = 0; count < CC_SHA1_DIGEST_LENGTH; count++) {
            [resultString appendFormat:@"%02X", digest[count]];
        }
        return resultString;
    } else {
        return nil;
    }
}

@end
